package figure;

//--------------------------------------------------------------------//
/**
 * 3xNgNX
 */
public class Vector3D extends Tuple3D{

/**  */
  private static final double TOLERANCE=1.0E-10;

/**
 * ftHgl(0,0,0)ŃxNg\z
 */
  public Vector3D(){
    this(0.0,0.0,0.0);
  }

/**
 * w肵ăxNg\z
 * @param x <i>x</i>
 * @param y <i>y</i>
 * @param z <i>z</i>
 */
  public Vector3D(double x,double y,double z){
    super(x,y,z);
  }

/**
 * W t ƓŃxNg\z
 * @param t QƂ <code>Tuple3D</code>
 */
  public Vector3D(Tuple3D t){
    this(t.x,t.y,t.z);
  }

/**
 * n_ƏI_w肵ăxNg\z
 * @param p0 n_
 * @param p1 I_
 */
  public Vector3D(Point3D p0,Point3D p1){
    this(p1.x-p0.x,p1.y-p0.y,p1.z-p0.z);
  }

//--------------------------------------------------------------------//
/**
 * XJ[{
 * @param a |XJ[
 */
  public void mul(double a){
    x*=a;
    y*=a;
    z*=a;
  }

//--------------------------------------------------------------------//
/**
 * xNg̑傫Ԃ
 * @return xNg̑傫
 */
  public double magnitude(){
    return Math.sqrt(x*x+y*y+z*z);
  }

//--------------------------------------------------------------------//
/**
 * xNg̑傫 2 Ԃ
 * @return xNg̑傫 2 
 */
  public double magnitudeSq(){
    return x*x+y*y+z*z;
  }

//--------------------------------------------------------------------//
/**
 * PʃxNg
 */
  public void normalize(){
    double mag=magnitude();
    if(mag<TOLERANCE) return;
    x=x/mag;
    y=y/mag;
    z=z/mag;
  }

//--------------------------------------------------------------------//
/**
 * ɍWԂ
 * @return ̃xNg̋ɍW\
 */
  public Vector3D polarCoordinates(){
    double mag=magnitude();
    if(mag<TOLERANCE) return new Vector3D();
    double theta=Math.acos(z/mag);
    double mag2=Math.sqrt(x*x+y*y);
    double phy=0.0;
    if(mag2>=TOLERANCE) phy=Math.acos(x/mag2);
    if(y<0.0) phy=-phy;
    return new Vector3D(mag,theta,phy);
  }

//--------------------------------------------------------------------//
/**
 * xNg̓ςԂ
 * @param v ςvZxNg
 * @return ̃xNgƎw肳ꂽxNgƂ̓
 */
  public double innerProduct(Vector3D v){
    return x*v.x+y*v.y+z*v.z;
  }

//--------------------------------------------------------------------//
/**
 * xNg̓ςԂ
 * @param v1 ςvZxNg
 * @param v2 ςvZxNg
 * @return w肳ꂽxNg̓
 */
  public static double innerProduct(Vector3D v1,Vector3D v2){
    return v1.x*v2.x+v1.y*v2.y+v1.z*v2.z;
  }

//--------------------------------------------------------------------//
/**
 * xNg̊OςԂ
 * @param v OςvZxNg
 * @return ̃xNgƎw肳ꂽxNgƂ̊O
 */
  public Vector3D exteriorProduct(Vector3D v){
    double vx=y*v.z-z*v.y;
    double vy=z*v.x-x*v.z;
    double vz=x*v.y-y*v.x;
    return new Vector3D(vx,vy,vz);
  }

//--------------------------------------------------------------------//
/**
 * xNg̊OςԂ
 * @param v1 OςvZxNg
 * @param v2 OςvZxNg
 * @return w肳ꂽxNg̊O
 */
  public static Vector3D exteriorProduct(Vector3D v1,Vector3D v2){
    double x=v1.y*v2.z-v1.z*v2.y;
    double y=v1.z*v2.x-v1.x*v2.z;
    double z=v1.x*v2.y-v1.y*v2.x;
    return new Vector3D(x,y,z);
  }

//--------------------------------------------------------------------//
/**
 * xNg̐pxԂ
 * @param v pxvZxNg
 * @return ̃xNgƎw肳ꂽxNgƂ̐px
 */
  public double angle(Vector3D v){
    double cc=innerProduct(v);
    double mag=magnitude()*v.magnitude();
    if(mag==0.0){
      return 0.0;
    }
    else{
      return Math.acos(cc/mag);
    }
  }

//--------------------------------------------------------------------//
/**
 * xNg̐pxԂ
 * @param v1 pxvZxNg
 * @param v2 pxvZxNg
 * @return w肳ꂽxNg̐px
 */
  public static double angle(Vector3D v1,Vector3D v2){
    double cc=innerProduct(v1,v2);
    double mag=v1.magnitude()*v2.magnitude();
    if(mag==0.0){
      return 0.0;
    }
    else{
      return Math.acos(cc/mag);
    }
  }

//--------------------------------------------------------------------//
/**
 * xNg̐̊pԂ
 * @param v1 ̊pvZxNg
 * @param v2 ̊pvZxNg
 * @param v3 ̊pvZxNg
 * @return w肳ꂽxNg̐̊p
 */
  public static double angle(Vector3D v1,Vector3D v2,Vector3D v3){
    Vector3D th1=v1.polarCoordinates();
    v2.rotZ(-th1.z);
    v2.rotY(-th1.y);
    v3.rotZ(-th1.z);
    v3.rotY(-th1.y);
    Vector3D th2=v2.polarCoordinates();
    Vector3D th3=v3.polarCoordinates();
    double angle=th3.z-th2.z;
    if(th2.y==th3.y){
      angle*=1.0-Math.cos(th2.y);
    }
    else{
      angle*=1.0-(Math.sin(th3.y)-Math.sin(th2.y))/(th3.y-th2.y);
    }
    return Math.abs(angle);
  }

//--------------------------------------------------------------------//
/**
 * f[^Ԃ
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    return "Vector3D\t"+x+"\t"+y+"\t"+z;
  }
}
