package planet;

//--------------------------------------------------------------------//
/**
 * Pv[NX<br>
 * <i>M</i> = <i>E</i> - <i>e</i> <code>sin</code><i>E</i><br>
 * <i>M</i> : ϋߓ_p (mean anomaly)<br>
 * <i>e</i> : S (eccentricity)<br>
 * <i>E</i> : Sߓ_p (eccentric anomaly)
 */
public class KeplerFunction{

/** Pv[̋e덷 */
  public static final double TOLERANCE=1.0E-8;

//--------------------------------------------------------------------//
/**
 * ϋߓ_p߂
 * @param e Sߓ_p
 * @param eccen S
 * @return ϋߓ_p
 */
  public static double meanAnomaly(double e,double eccen){
    return e-eccen*Math.sin(e);
  }

//--------------------------------------------------------------------//
/**
 * Sߓ_p߂<br>
 * Newtion @gp
 * @param m ϋߓ_p
 * @param eccen S
 * @return Sߓ_p
 */
  public static double eccentricAnomaly(double m,double eccen){
    double ei=m+eccen*Math.sin(m);
    double mi=ei-eccen*Math.sin(ei);
    double dm=Math.abs(m-mi);
    while(dm>TOLERANCE){
      ei=ei+(m-mi)/(1.0-eccen*Math.cos(ei));
      mi=ei-eccen*Math.sin(ei);
      dm=Math.abs(m-mi);
    }
    return ei;
  }
}
