package planet;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.FlowLayout;
import java.awt.Panel;
import java.awt.Point;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.Map;
import java.util.HashMap;
import planet.action.ActionButton;
import planet.action.MovePointerAction;
import planet.action.RotateAction;
import planet.action.SetBaseButton;
import planet.action.SimpleAction;
import planet.action.ViewModeAction;
import planet.action.ViewModeCheckbox;

//--------------------------------------------------------------------//
/**
 * ANVǗNX
 */
public class PlanetActionManager
  implements MouseListener,MouseMotionListener,KeyListener{

/** _oxω */
  public static final double THETA_X=15.0;

/** _ܓxω */
  public static final double THETA_Y=10.0;

/** \LoX */
  protected PlanetViewCanvas canvas;

/** }EXʒu */
  protected Point mousePoint;

/** ANVL[i[}bv */
  protected Map keyMap;

/** pl */
  protected Panel controlPanel;

/** f|C^؂ւ\ boolean ^ */
  protected boolean stbase;

/**
 * ANVǗIuWFNg\z
 * @param canvas \LoX
 */
  public PlanetActionManager(PlanetViewCanvas canvas){
    this.canvas=canvas;
    canvas.addMouseListener(this);
    canvas.addMouseMotionListener(this);
    canvas.addKeyListener(this);
    mousePoint=new Point();

    keyMap=new HashMap();
    controlPanel=new Panel(new FlowLayout());
    addActions();
    stbase=false;
  }

//--------------------------------------------------------------------//
/**
 * ANVǉ
 */
  protected void addActions(){
// f|C^؂ւ{^
    ActionButton setBase=new SetBaseButton(this,"Set Base");
    CheckboxGroup group=new CheckboxGroup();
// \[hI{^
    Checkbox inner=new ViewModeCheckbox
      (canvas,"Inner planets",group,true,Planet.INNER_PLANET);
    Checkbox outer=new ViewModeCheckbox
      (canvas,"Outer planets",group,false,Planet.OUTER_PLANET);
// ֎_]
    SimpleAction east=new RotateAction(canvas,THETA_X,0.0);
// ֎_]
    SimpleAction west=new RotateAction(canvas,-THETA_X,0.0);
// k֎_]
    SimpleAction north=new RotateAction(canvas,0.0,THETA_Y);
// 쑤֎_]
    SimpleAction south=new RotateAction(canvas,0.0,-THETA_Y);
// \[hI
    SimpleAction mode=new ViewModeAction(canvas);
// f|C^ړ
    SimpleAction before1=new MovePointerAction(canvas,0,-1);
    SimpleAction next1=new MovePointerAction(canvas,0,1);
    SimpleAction before2=new MovePointerAction(canvas,1,-1);
    SimpleAction next2=new MovePointerAction(canvas,1,1);

    keyMap.put(new Integer(KeyEvent.VK_ADD),next1);
    keyMap.put(new Integer(KeyEvent.VK_SEMICOLON),next1);
    keyMap.put(new Integer(KeyEvent.VK_SUBTRACT),before1);
    keyMap.put(new Integer(KeyEvent.VK_MINUS),before1);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD1),next2);
    keyMap.put(new Integer(KeyEvent.VK_1),next2);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD0),before2);
    keyMap.put(new Integer(KeyEvent.VK_0),before2);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD5),mode);
    keyMap.put(new Integer(KeyEvent.VK_5),mode);
    keyMap.put(new Integer(KeyEvent.VK_C),mode);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD4),east);
    keyMap.put(new Integer(KeyEvent.VK_LEFT),east);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD6),west);
    keyMap.put(new Integer(KeyEvent.VK_RIGHT),west);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD2),north);
    keyMap.put(new Integer(KeyEvent.VK_DOWN),north);
    keyMap.put(new Integer(KeyEvent.VK_NUMPAD8),south);
    keyMap.put(new Integer(KeyEvent.VK_UP),south);

    controlPanel.add(setBase);
    controlPanel.add(inner);
    controlPanel.add(outer);
  }

//--------------------------------------------------------------------//
/**
 * plԂ
 * @return pl
 */
  public Panel getControlPanel(){
    return controlPanel;
  }

//--------------------------------------------------------------------//
/**
 * f|C^؂ւ
 */
  public void setBase(){
    stbase=true;
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    mousePoint.setLocation(e.getX(),e.getY());
    Planet p1=canvas.getModel().getPlanet
      (mousePoint.x,mousePoint.y,canvas.getViewMode());
    if(p1!=null){
      if(stbase){
      	canvas.getPointer().set(0,p1);
      	stbase=false;
      }
      else{
      	canvas.getPointer().set(1,p1);
      }
    }
    canvas.repaint();
  }

//--------------------------------------------------------------------//
/**
 * }EX{^𗣂̏s
 * @param e }EXANVƂCxg
 */
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXNbN̏s
 * @param e }EXANVƂCxg
 */
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgɓ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgȍs
 * @param e }EXANVƂCxg
 */
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXړ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseMoved(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXhbȌs
 * @param e }EXANVƂCxg
 */
  public void mouseDragged(MouseEvent e){
    int x=e.getX();
    int y=e.getY();
    canvas.rotate(mousePoint.x-x,y-mousePoint.y);
    mousePoint.setLocation(x,y);
    canvas.repaint();
  }

//--------------------------------------------------------------------//
/**
 * L[̏s
 * @param e L[ANVƂCxg
 */
  public void keyPressed(KeyEvent e){
    Object value=keyMap.get(new Integer(e.getKeyCode()));
    if(value instanceof SimpleAction){
      ((SimpleAction)value).doAction();
    }
  }

//--------------------------------------------------------------------//
/**
 * L[𗣂̏s
 * @param e L[ANVƂCxg
 */
  public void keyReleased(KeyEvent e){
  }

//--------------------------------------------------------------------//
/**
 * L[^Cv̏s
 * @param e L[ANVƂCxg
 */
  public void keyTyped(KeyEvent e){
  }
}
