package planet;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.io.InputStream;
import java.net.URL;
import animation.Animator;
import planet.io.PlanetDataReader;

//--------------------------------------------------------------------//
/**
 * f܂ł̋\Avbg CNX
 * @author aG
 * @version 2.2.5
 */
public class PlanetApplet extends Applet{

/** G[bZ[W */
  protected String message;

/** \Aj[^ */
  protected Animator animator;

//--------------------------------------------------------------------//
/**
 * Avbg
 */
  public void init(){
    setLayout(new BorderLayout());
    Color bgColor=getTagColor("backgroundcolor");
    Color fgColor=getTagColor("foregroundcolor");
    int waitTime=100;
    double wt=getTagNumber("waittime");
    if(wt!=Double.NaN) waitTime=(int)wt;
    PlanetViewCanvas canvas=new PlanetViewCanvas
      (getDataModel(),message,getTagFont(),bgColor,fgColor);
    PlanetActionManager manager=new PlanetActionManager(canvas);
    add(canvas,BorderLayout.CENTER);
    add(manager.getControlPanel(),BorderLayout.SOUTH);
    animator=new PlanetAnimator(canvas,waitTime);
  }

//--------------------------------------------------------------------//
/**
 * \[Xj
 */
  public void destroy(){
    removeAll();
  }

//--------------------------------------------------------------------//
/**
 * Aj[VJn
 */
  public void start(){
    animator.start();
  }

//--------------------------------------------------------------------//
/**
 * Aj[V~
 */
  public void stop(){
    animator.stop();
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽff[^Ԃ
 * @return HTML^OŎw肳ꂽff[^
 */
  public PlanetDataModel getDataModel(){
    String dataName=getParameter("pldata");
    if(dataName==null) dataName="planet.dat";
    message=null;
    try{
      Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
    }
    catch(SecurityException ex){
      message=String.valueOf(ex);
      return null;
    }
    PlanetDataModel model=new PlanetDataModel();
    try{
      PlanetDataReader reader=new PlanetDataReader(model);
      reader.read(new URL(getDocumentBase(),dataName));
      return model;
    }
    catch(Exception ex){
      message=String.valueOf(ex);
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽFԂ
 * @param name p[^
 * @return HTML^OŎw肳ꂽF
 */
  protected Color getTagColor(String name){
    String value=getParameter(name);
    if(value==null) return null;
    try{
      return new Color(Integer.parseInt(value,16));
    }
    catch(NumberFormatException ex){
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽtHgԂ
 * @return HTML^OŎw肳ꂽtHg
 */
  protected Font getTagFont(){
    String fontName=getParameter("fontname");
    if(fontName==null) fontName="Serif";

    String s=getParameter("fontstyle");
    int fontStyle=Font.PLAIN;
    if(s!=null){
      if(s.equals("bold")){
      	fontStyle=Font.BOLD;
      }
      else if(s.equals("italic")){
      	fontStyle=Font.ITALIC;
      }
    }

    s=getParameter("fontsize");
    int fontSize=14;
    try{
      fontSize=Integer.parseInt(s);
    }
    catch(NumberFormatException ex){
      ex.printStackTrace();
    }

    return new Font(fontName,fontStyle,fontSize);
  }

//--------------------------------------------------------------------//
/**
 * HTML^OŎw肳ꂽlԂ
 * @param name p[^
 * @return HTML^OŎw肳ꂽl
 */
  protected double getTagNumber(String name){
    String value=getParameter(name);
    if(value==null) return Double.NaN;
    try{
      return Double.parseDouble(value);
    }
    catch(NumberFormatException ex){
      return Double.NaN;
    }
  }

//--------------------------------------------------------------------//
/**
 * AvbgԂ
 * @return Avbg܂ޕ
 */
  public String getAppletInfo(){
    return "Applet of distance between planets\n"
      	  +"Author K.Higuchi";
  }

//--------------------------------------------------------------------//
/**
 * ̃Avbg߂p[^Ԃ
 * @return Avbg߂p[^i[z
 */
  public String[][] getParameterInfo(){
    return new String[][]
      {{"pldata","String","Planets data file name."},
       {"fontname","String","Font name. Default is Serif."},
       {"fontstyle","int","Font style. Default is Font.PLAIN."},
       {"fontsize","int","Font size. Default is 14."},
       {"backgroundcolor","hexadecimal RGB number",
      	"The color of background."},
       {"foregroundcolor","hexadecimal RGB number",
      	"The color of foreground."},
       {"waittime","int","Animation wiat time in millisec."}};
  }
}
