package planet;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;

//--------------------------------------------------------------------//
/**
 * ڐNX
 */
public class PlanetScale extends Rectangle{

/** ڐ̃ftHgl */
  public static final int DEFAULT_SCALE_SIZE=3;

/** \ */
  protected int length;

/** ڐ */
  protected int scaleSize;

/** x */
  protected String label;

/** ڐ\ʒu */
  protected Point scalePoint;

/** x\ʒu */
  protected Point labelPoint;

/**
 * ڐIuWFNg\z
 * @param length \
 * @param label x
 */
  public PlanetScale(int length,String label){
    super();
    this.length=length;
    this.label=label;
    scaleSize=DEFAULT_SCALE_SIZE;
    scalePoint=new Point();
    labelPoint=new Point();
  }

//--------------------------------------------------------------------//
/**
 * CX^XԂ
 * @param rcoef 1AU ̃sNZ
 * @param radius `͈͔a
 */
  public static PlanetScale getPlanetScale(double rcoef,double radius){
    double scp=Math.floor(Math.log(radius)/Math.log(10.0));
    double scale=Math.pow(10.0,scp);
    int length=(int)(rcoef*scale);
    if(scale>=1.0){
      return new PlanetScale(length,String.valueOf((int)scale)+"AU");
    }
    else{
      return new PlanetScale(length,String.valueOf(scale)+"AU");
    }
  }

//--------------------------------------------------------------------//
/**
 * ʒuݒ肷
 * @param x <i>x</i>W
 * @param y <i>y</i>W
 */
  public void setLocation(int x,int y){
    translate(x-this.x,y-this.y);
  }

//--------------------------------------------------------------------//
/**
 * Eݒ肷
 * @param x <i>x</i>W
 * @param y <i>y</i>W
 * @param width 
 * @param height 
 */
  public void setBounds(int x,int y,int width,int height){
    translate(x-this.x,y-this.y);
    setSize(width,height);
  }

//--------------------------------------------------------------------//
/**
 * ʒuړ
 * @param dx ړʂ<i>x</i>
 * @param dy ړʂ<i>y</i>
 */
  public void translate(int dx,int dy){
    super.translate(dx,dy);
    scalePoint.translate(dx,dy);
    labelPoint.translate(dx,dy);
  }

//--------------------------------------------------------------------//
/**
 * ڐTCYݒ肷
 * @param fm tHggbNX
 */
  public void setSize(FontMetrics fm){
    int textw=fm.stringWidth(label);
    int texth=fm.getHeight();
    int scaleY=y+scaleSize;
    int textY=scaleY+1+scaleSize+fm.getAscent();
    int deltaX=(length-textw)/2;
    if(length>textw){
      scalePoint.setLocation(x,scaleY);
      labelPoint.setLocation(x+deltaX,textY);
      setSize(length,2*scaleSize+texth+1);
    }
    else{
      scalePoint.setLocation(x-deltaX,scaleY);
      labelPoint.setLocation(x,textY);
      setSize(textw,2*scaleSize+texth+1);
    }
  }

//--------------------------------------------------------------------//
/**
 * ڐ`悷
 * @param g `悷OtBbNXReLXg
 */
  public void paint(Graphics g){
    g.drawLine(scalePoint.x,scalePoint.y,
      	       scalePoint.x+length,scalePoint.y);
    g.drawLine(scalePoint.x,scalePoint.y+1,
      	       scalePoint.x+length,scalePoint.y+1);
    g.drawLine(scalePoint.x,scalePoint.y-scaleSize,
      	       scalePoint.x,scalePoint.y+scaleSize+1);
    g.drawLine(scalePoint.x+length,scalePoint.y-scaleSize,
      	       scalePoint.x+length,scalePoint.y+scaleSize+1);
    g.drawString(label,labelPoint.x,labelPoint.y);
  }

//--------------------------------------------------------------------//
/**
 * ڐ`悷
 * @param g `悷OtBbNXReLXg
 * @param color `F
 */
  public void paint(Graphics g,Color color){
    g.setColor(color);
    paint(g);
  }
}
