package planet;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

//--------------------------------------------------------------------//
/**
 * eLXg{bNXNX
 */
public class TextBox extends Rectangle{

/** zu\萔 */
  public static final float CENTER_ALIGNMENT=0.5f;

/** zu\萔 */
  public static final float LEFT_ALIGNMENT=0.0f;

/** Ezu\萔 */
  public static final float RIGHT_ALIGNMENT=1.0f;

/** zu\萔 */
  public static final float TOP_ALIGNMENT=0.0f;

/** zu\萔 */
  public static final float BOTTOM_ALIGNMENT=1.0f;

/** \ */
  protected static final int MARGIN=2;

/** tHggbNX */
  protected FontMetrics fm;

/** ڕ\ */
  protected int itemHeight;

/** eLXgiXg */
  protected ArrayList texts;

/**
 * ftHgʒuɃeLXg{bNX\z
 * @param fm tHggbNX
 */
  public TextBox(FontMetrics fm){
    this(fm,0,0);
  }

/**
 * ʒuw肵ăeLXg{bNX\z
 * @param fm tHggbNX
 * @param x <i>x</i>W
 * @param y <i>y</i>W
 */
  public TextBox(FontMetrics fm,int x,int y){
    super(x,y,0,2*MARGIN);
    this.fm=fm;
    itemHeight=fm.getHeight();
    texts=new ArrayList();
  }

//--------------------------------------------------------------------//
/**
 * ڂǉ
 * @param string ǉ鍀
 */
  public void add(String string){
    width=Math.max(width,fm.stringWidth(string)+2*MARGIN);
    height+=itemHeight;
    texts.add(string);
  }

//--------------------------------------------------------------------//
/**
 * ڂǉ
 * @param strings ǉ鍀ڂi[z
 */
  public void add(String strings[]){
    for(int i=0;i<strings.length;i++){
      add(strings[i]);
    }
  }

//--------------------------------------------------------------------//
/**
 * ڂǉ
 * @param c ǉ鍀ڂ̃RNV
 */
  public void add(Collection c){
    Iterator itr=c.iterator();
    while(itr.hasNext()){
      Object value=itr.next();
      if(value!=null) add(String.valueOf(value));
    }
  }

//--------------------------------------------------------------------//
/**
 * ڂu
 * @param index ڂ̃CfbNX
 * @param string u鍀
 */
  public void set(int index,String string){
    width=Math.max(width,fm.stringWidth(string)+2*MARGIN);
    texts.set(index,string);
  }

//--------------------------------------------------------------------//
/**
 * ڂԂ
 * @param index ڂ̃CfbNX
 * @return w肳ꂽʒuɂ鍀
 */
  public String get(int index){
    return (String)texts.get(index);
  }

//--------------------------------------------------------------------//
/**
 * ڂ폜
 * @param index ڂ̃CfbNX
 */
  public void remove(int index){
    texts.remove(index);
    height=itemHeight*getListSize();
  }

//--------------------------------------------------------------------//
/**
 * Sڂ
 */
  public void clear(){
    texts.clear();
    super.setSize(0,2*MARGIN);
  }

//--------------------------------------------------------------------//
/**
 * ڐԂ
 * @return ڐ
 */
  public int getListSize(){
    return texts.size();
  }

//--------------------------------------------------------------------//
/**
 * eLXg{bNX`悷
 * @param g `悷OtBbNXReLXg
 */
  public void paint(Graphics g){
    int listCount=getListSize();
    int x0=x+MARGIN;
    int y0=y+MARGIN+fm.getAscent();
    for(int i=0;i<listCount;i++){
      g.drawString(texts.get(i).toString(),x0,y0);
      y0+=itemHeight;
    }
  }

//--------------------------------------------------------------------//
/**
 * eLXg{bNX`悷
 * @param g `悷OtBbNXReLXg
 * @param colors `Fi[z
 */
  public void paint(Graphics g,Color colors[]){
    int listNumber=Math.min(getListSize(),colors.length);
    int x0=x+MARGIN;
    int y0=y+MARGIN+fm.getAscent();
    for(int i=0;i<listNumber;i++){
      g.setColor(colors[i]);
      g.drawString(texts.get(i).toString(),x0,y0);
      y0+=itemHeight;
    }
  }

//--------------------------------------------------------------------//
/**
 * wihׂ
 * @param g `悷OtBbNXReLXg
 * @param bgColor wiF
 */
  public void paintBackground(Graphics g,Color bgColor){
    g.setColor(bgColor);
    g.fillRect(x,y,width,height);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 * @param panelSize plTCY
 * @param strings `悷镶i[z
 * @param alignmentX zu
 * @param alignmentY czu
 * @param bgColor wiF
 * @param fgColor OiF
 * @return `̈\ Rectangle
 */
  public static Rectangle paintStrings
    (Graphics g,Dimension panelSize,String strings[],
     float alignmentX,float alignmentY,Color bgColor,Color fgColor){

    TextBox tbox=new TextBox(g.getFontMetrics());
    tbox.add(strings);
    int x=(int)(alignmentX*(float)(panelSize.width-tbox.width));
    int y=(int)(alignmentY*(float)(panelSize.height-tbox.height));
    tbox.setLocation(x,y);
    tbox.paintBackground(g,bgColor);
    g.setColor(fgColor);
    tbox.paint(g);
    return tbox;
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 * @param panelSize plTCY
 * @param strings `悷镶i[z
 * @param colors `Fi[z
 * @param alignmentX zu
 * @param alignmentY czu
 * @param bgColor wiF
 * @param fgColor OiF
 * @return `̈\ Rectangle
 */
  public static Rectangle paintStrings
    (Graphics g,Dimension panelSize,String strings[],Color colors[],
     float alignmentX,float alignmentY,
     Color bgColor,Color fgColor){

    TextBox tbox=new TextBox(g.getFontMetrics());
    tbox.add(strings);
    int x=(int)(alignmentX*(float)(panelSize.width-tbox.width));
    int y=(int)(alignmentY*(float)(panelSize.height-tbox.height));
    tbox.setLocation(x,y);
    tbox.paintBackground(g,bgColor);
    g.setColor(fgColor);
    tbox.paint(g,colors);
    return tbox;
  }

//--------------------------------------------------------------------//
/**
 * f[^
 * @return ̃IuWFNg̕\
 */
  public String toString(){
    StringBuffer sb=new StringBuffer();
    int number=getListSize();
    for(int i=0;i<number;i++){
      sb.append(texts.get(i));
      sb.append('\n');
    }
    return sb.toString();
  }
}