package planet.calendar;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.util.Calendar;
import java.util.TimeZone;

//--------------------------------------------------------------------//
/**
 * J_[NX
 */
public class CalendarFormat{

/** GMT̃^C][ */
  protected static final TimeZone GMT=TimeZone.getTimeZone("GMT");

/** [J̃^C][ */
  protected static final TimeZone LOCAL=TimeZone.getDefault();

/** l */
  protected static final DecimalFormat
    DFORM=new DecimalFormat("#######0.0000");

/** J_[ */
  protected CalendarForPlanet calendar;

/** t */
  protected DateFormat dateFormat;

/**
 * J_[\z
 * @param calendar J_[
 */
  public CalendarFormat(CalendarForPlanet calendar){
    this.calendar=calendar;
    dateFormat=DateFormat.getDateTimeInstance
      	      	 (DateFormat.MEDIUM,DateFormat.MEDIUM);
  }

//--------------------------------------------------------------------//
/**
 * [Jt\o
 * @return [Jt̕\
 */
  public String getLocalDateString(){
    dateFormat.setTimeZone(LOCAL);
    return "JST: "+dateFormat.format(calendar.getDate());
  }

//--------------------------------------------------------------------//
/**
 * GMT t\o
 * @return GMT t̕\
 */
  public String getGMTDateString(){
    dateFormat.setTimeZone(GMT);
    return "GMT: "+dateFormat.format(calendar.getDate());
  }

//--------------------------------------------------------------------//
/**
 * EX\o
 * @return EX̕\
 */
  public String getJDString(){
    return "JD:  "+DFORM.format(calendar.getJulianDay());
  }

//--------------------------------------------------------------------//
/**
 * EX\o
 * @return EX̕\
 */
  public String getMJDString(){
    return "MJD:   "+DFORM.format(calendar.getModifiedJulianDay());
  }

//--------------------------------------------------------------------//
/**
 * ftHg̓t\Ԃ
 * @return ftHg̓ti[z
 */
  public String[] getDefaultStrings(){
    return new String[]{getLocalDateString(),
      	      	        getGMTDateString(),
      	      	        getJDString(),
      	      	        getMJDString()};
  }
}
