package planet.io;
import java.awt.Color;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.StringTokenizer;
import fileio.TextDataReader;
import planet.Planet;
import planet.PlanetDataModel;
import planet.PlanetList;

//--------------------------------------------------------------------//
/**
 * ff[^ǂݍ݃NX
 */
public class PlanetDataReader extends TextDataReader{

/** ff[^f */
  protected PlanetDataModel model;

/**
 * ff[^ǂݍ݃IuWFNg\z
 * @param model ff[^f
 */
  public PlanetDataReader(PlanetDataModel model){
    this.model=model;
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param br ̓[_[
 * @throws IOException 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void readData(BufferedReader br) throws Exception{
    PlanetList list=model.getList();
    double epoch=2451545.0;
    list.clear();
    while(true){
      String line=br.readLine();
      if(line==null) break;
      StringTokenizer st=new StringTokenizer(line);
      if(st.countTokens()>=10){
      	Planet planet=parsePlanet(st);
      	if(planet!=null){
      	  list.add(planet);
      	}
      }
      else if(st.countTokens()>=4){
      	st.nextToken();
      	model.setThreshold(st.nextToken());
      	st.nextToken();
      	model.setEpoch(st.nextToken());
      }
      else if(st.countTokens()>=2){
      	st.nextToken();
      	model.setThreshold(st.nextToken());
      }
    }
    br.close();
    model.init();
  }

//--------------------------------------------------------------------//
/**
 * ff[^ǂݍ
 * @param st f[^ǂݍ <code>StringTokenizer</code>
 * @return ǂݍ܂ꂽff[^<br>
 *         f[^ǂݍ߂Ȃꍇ null Ԃ
 */
  protected Planet parsePlanet(StringTokenizer st){
    if(st.countTokens()<10) return null;
    try{
      String name=st.nextToken();
      Color color=new Color(Integer.parseInt(st.nextToken(),16));
      int radius=Math.max(Integer.parseInt(st.nextToken()),1);
      double sma=Double.parseDouble(st.nextToken());
      double eccen=Double.parseDouble(st.nextToken());
      double lofp=Math.toRadians(Double.parseDouble(st.nextToken()));
      double lofan=Math.toRadians(Double.parseDouble(st.nextToken()));
      double inc=Math.toRadians(Double.parseDouble(st.nextToken()));
      double meanl=Math.toRadians(Double.parseDouble(st.nextToken()));
      double pinv=Double.parseDouble(st.nextToken());
      if(pinv!=0.0) pinv=2.0*Math.PI/(365.25*pinv);
      return new Planet(name,color,radius,sma,eccen,lofp,lofan,inc,
      	      	      	meanl,pinv);
    }
    catch(NumberFormatException ex){
      return null;
    }
  }
}
